#!/bin/sh
# Built on TCL v4.0.2
# Required extensions:
#	compiletc
#    bison
#    diffutils
#    file
#    findutils
#    flex
#    gawk
#    gcc
#     gcc_libs
#      binutils
#       mpfr
#        gmp
#        mpc
#    grep
#    m4
#    make
#    patch
#    pkg-config
#     glib2
#     popt
#    sed
#    e2fsprogs_base-dev
#    eglibc_base-dev
#    freetype_base-dev
#    gcc_base-dev
#    imlib2_base-dev
#    jpeg_base-dev
#    libpng_base-dev
#    linux-3.0.1_api_headers
#    util-linux_base-dev
#    zlib_base-dev
#	squashfs-tools-4.x
#	tar
#	libxml2-dev
#	 libxml2
#	 libxml2-bin
#	guile-dev
#	 guile
#	  ncurses
#          ncurses-common
#	  readline
#	  libltdl
#	 libtool-dev
#	  libtool
#	 gmp-dev
#	bash
#	gzip
#	texinfo
#	coreutils
#	 acl
#	  libattr
#	 attr
#	 libcap

getTime.sh

installExtension() {
	if [ ! -e /usr/local/tce.installed/$1 ]; then
		echo "Installing "$1" ..."
		
		if [ -e $TCEDIR/optional/$1.tcz ]; then
			tce-load -i $1
		else
			tce-load -wi $1
		fi
		
		[ ! -e /usr/local/tce.installed/$1 ] && echo "Error: Extension "$1" not installed! Aborting" && exit
	fi
}

createExtension() {
	mksquashfs $1 $1.tcz -noappend
	[ ! -e $1.tcz ] && echo "Error: "$1".tcz not created! Aborting" && exit
}

unpackSrc() {
	#unpack source
	if [ -e $1.tar.bz2 ]; then
		tar -jxf $1.tar.bz2
	elif [ -e $1.tb2 ]; then
		tar -jxf $1.tb2
	elif [ -e $1.tbz ]; then
		tar -jxf $1.tbz
	elif [ -e $1.tar.gz ]; then
		tar -zxf $1.tar.gz
	elif [ -e $1.tgz ]; then
		tar -zxf $1.tgz
	elif [ -e $1.tar.xz ]; then
		tar -Jxf $1.tar.xz
	elif [ -e $1.txz ]; then
		tar -Jxf $1.txz
	elif [ -e $1.tar.lzma ]; then
		tar -xf $1.tar.lzma --lzma
	elif [ -e $1.tlz ]; then
		tar -xf $1.tlz --lzma
	else
		echo "Source "$1" not found! Aborting" && exit
	fi
}

# Install these extensions automagically
export EXTS="compiletc
squashfs-tools-4.x
tar
libxml2-dev
guile-dev
bash
gzip
texinfo
coreutils"

export TCEDIR=`cat /opt/.tce_dir`
export CFLAGS="-march=i486 -mtune=i686 -Os -pipe"
export CXXFLAGS=$CFLAGS" -fno-exceptions -fno-rtti"
export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig
export EXTNAME="autogen"
export VER="-5.12"
export DESTDIR=`pwd`/$EXTNAME
export PKGNAME=$EXTNAME$VER

for f in $EXTS; do
	installExtension $f
done

unpackSrc $PKGNAME

mkdir -p $EXTNAME-dev/usr/local/lib $EXTNAME-dev/usr/local/bin $EXTNAME-dev/usr/local/share/$EXTNAME

cd $PKGNAME

./configure --with-libguile --with-libxml2 && make && make check 2>&1 | tee ../$EXTNAME.test && make install-strip || exit

cd $DESTDIR

mv usr/local/include $DESTDIR-dev/usr/local
mv usr/local/share/pkgconfig $DESTDIR-dev/usr/local/lib
mv usr/local/lib/*a $DESTDIR-dev/usr/local/lib
mv usr/local/bin/autoopts-config $DESTDIR-dev/usr/local/bin
mv usr/local/share/aclocal $DESTDIR-dev/usr/local/share
mv usr/local/share/$EXTNAME/libopts*.tar.gz $DESTDIR-dev/usr/local/share/$EXTNAME
mv usr/local/share/$EXTNAME/*.m4 $DESTDIR-dev/usr/local/share/$EXTNAME
mv usr/local/share/$EXTNAME/*.def $DESTDIR-dev/usr/local/share/$EXTNAME

rm -rf usr/local/share/man usr/local/share/info

cd ..

createExtension $EXTNAME
createExtension $EXTNAME-dev

rm -rf $EXTNAME$VER $EXTNAME $EXTNAME-dev

# Create extension support files and test
installExtension "submitqc4"

submitqc4
